-- Connect Four (Vier Gewinnt) V.001 by chill (based on Connect Four)
-- Thx To UwVerlosser who is the best ascii art scripter :), alos viewed in MicroSoft SansSerif Size 8

--Best Viewed with Font (recommended):

-- 	MicroSoft SansSerif Size 8

--	Courier
--	Courier New
--	Fixedsys
--	Lucida Console
--	MS Mincho
--	OCR A Extended
--	SimSun 
--	TeleText	
--	TeleTextDH
--	Terminal
--	WST



---------------------------------------------
---------------------------------------------
-- ************* MAIN SCRIPT ************* --
---------------------------------------------
---------------------------------------------

-- THE TABLE

ConnectX = {}
-- Games
ConnectX.Games = {}
--Players
ConnectX.Players = {}

------------------------------------------
------------------------------------------
-- For default Values
ConnectX.Default = {}
ConnectX.Default.Font = "SansSerif"
ConnectX.Default.Matrix = {
	columns = 7,		-- Number of columns
	lines = 6,		-- Number of lines
	connects = 4,		-- Number of connects to win.
}

------------------------------------------
------------------------------------------
-- For Data
ConnectX.Data = {}
ConnectX.Data.Help = "--- ConnectX Help ( by chill ) ---\r\n\r\n"..
	"\t-----------------------------------\r\n"..
	"\tcx invite <nick>    - Invite a user\r\n"..
	"\tinviteom <nick> <Columns,Lines,Connects>    - Max (20,20,X), Invites a user to your own Matrix\r\n"..
	"\tfont <Text/SansSerif>   - Sets your font\r\n"..
	"\tshowboard    - Shows you the board\r\n"..
	"\tquit    - Quit the current game\r\n"..
	"\thelp    - Shows you ConnectX help\r\n"..
	"\t-----------------------------------\r\n"

------------------------------------------
------------------------------------------
-- For Fonts
ConnectX.Fonts = {}
ConnectX.Draw = {}

-- TEXT STYLE
ConnectX.Fonts.Text = {
	[0] = " ",
	[1] = "X",
	[2] = "O",
}
-- Draw in Text Style
function ConnectX.Draw.Text(sgame)

	local sboard = sgame.field

	local smatrix = sgame.matrix

	local line5 = string.rep(" ",5)
	local sline = "_____"..string.char(166)
	local CXField = "\r\n\r\n\t\t>> Connects: "..sgame.matrix.connects.." <<\r\n\r\n\t\t "

	for i = 1,smatrix.columns do
		if i < 10 then
			CXField = CXField.."  "..i.."   "
		else
			CXField = CXField.."  "..i.."  "
		end
	end
	CXField = CXField.."\r\n\r\n"

	for i2 = smatrix.lines,1,-1 do
		CXField = CXField.."\t\t"..string.char(166)
		for _ = 1,smatrix.columns do
			CXField = CXField..line5..string.char(166)
		end
		CXField = CXField.."\r\n\t\t"..string.char(166)
		for i = 1,smatrix.columns do
			CXField = CXField.."  "..ConnectX.Fonts.Text[sboard[i..i2]].."  "..string.char(166)
		end
		CXField = CXField.."\r\n\t\t"..string.char(166)
		for _ = 1,smatrix.columns do
			CXField = CXField..sline
		end
		CXField = CXField.."\r\n"
	end

	CXField = CXField.."\r\n"

	table.foreachi(sgame.players, function(i,v)
		if (v[1] == sgame.turn[1]) then
			CXField = CXField.."\t\t-->  "..v[1].." : "..ConnectX.Fonts.Text[i].."\r\n"
		else
			CXField = CXField.."\t\t"..v[1].." : "..ConnectX.Fonts.Text[i].."\r\n"
		end
	end)

	return(CXField)
end


-- MICROSOFT SANSSERIF STYLE
ConnectX.Fonts.SansSerif = {
	[0] = "  .  ",
	[1] = "['X]",
	[2] = "(( ))",
}
-- Draw in MicroSoft SansSerif Style
function ConnectX.Draw.SansSerif(sgame)

	local sboard = sgame.field

	local smatrix = sgame.matrix

	local line5 = string.rep(" ",13)
	local sline = "___.___"..string.char(166)
	local CXField = "\r\n\r\n\t\t>> Connects: "..sgame.matrix.connects.." <<\r\n\r\n\t\t"
	for i = 1,smatrix.columns do
		if i < 10 then
			CXField = CXField.."'    _"..i.."_   "
		else
			CXField = CXField.."'   _"..i.."_  "
		end
	end
	CXField = CXField.."'\r\n\r\n"

	for i2 = smatrix.lines,1,-1 do
		CXField = CXField.."\t\t"..string.char(166)
		for _ = 1,smatrix.columns do
			CXField = CXField..line5..string.char(166)
		end
		CXField = CXField.."\r\n\t\t"..string.char(166)
		for i = 1,smatrix.columns do
			CXField = CXField.."    "..ConnectX.Fonts.SansSerif[sboard[i..i2]].."    "..string.char(166)
		end
		CXField = CXField.."\r\n\t\t"..string.char(166)
		for _ = 1,smatrix.columns do
			CXField = CXField..sline
		end
		CXField = CXField.."\r\n"
	end

	CXField = CXField.."\r\n"

	table.foreachi(sgame.players, function(i,v)
		if (v[1] == sgame.turn[1]) then
			CXField = CXField.."\t\t-->  "..v[1].." : "..ConnectX.Fonts.SansSerif[i].."\r\n"
		else
			CXField = CXField.."\t\t"..v[1].." : "..ConnectX.Fonts.SansSerif[i].."\r\n"
		end
	end)

	return(CXField)
end

------------------------------------------
------------------------------------------
-- For Functions
ConnectX.Funcs = {}

-- Create a Game
function ConnectX.Funcs.CreateGame(shub, nicks, smatrix)
	
	-- Get a New Game Index
	local sindex = ""
	local found = 1
	while found do
		sindex = sindex..string.char(math.random(48,122))
		if not ConnectX.Games[sindex] then
			found = nil
		end
	end

	table.foreachi(nicks, function(i,nickname)
		ConnectX.Players[nickname] = {sindex,i}
	end)

	-- ConnectX Game
	ConnectX.Games[sindex] = {}

	local sgame = ConnectX.Games[sindex]

	sgame.index = sindex
	sgame.hub = shub


	-- build field
	sgame.matrix = {}
	sgame.matrix = smatrix or ConnectX.Default.Matrix

	sgame.field = {}
	
	for i = 1,sgame.matrix.columns do
		for i2 = 1,sgame.matrix.lines do
			sgame.field[i..i2] = 0
		end
	end

	sgame.icounter = { 0,sgame.matrix.columns*sgame.matrix.lines }

	-- game players
	sgame.players = {}
	table.foreachi(nicks, function(_,nickname)
		table.insert(sgame.players,{nickname,ConnectX.Default.Font})
	end)

	-- game turn
	sgame.turn = {}
	table.foreachi(nicks, function(_,nickname)
		table.insert(sgame.turn,nickname)
	end)

	-- sgame Functions

	sgame.SendToPlayerNum = ConnectX.Funcs.SendToPlayerNum
	sgame.SendToPlayers = ConnectX.Funcs.SendToPlayers
	sgame.SendBoard = ConnectX.Funcs.SendBoard

	sgame.SwitchPlayers = ConnectX.Funcs.SwitchPlayers

	sgame.CheckData = ConnectX.Funcs.CheckData

	sgame.InsertX = ConnectX.Funcs.InsertX

	sgame.CheckForWin = ConnectX.Funcs.CheckForWin
	sgame.CheckForEnd = ConnectX.Funcs.CheckForEnd

	sgame.DelGame = ConnectX.Funcs.DelGame

	return sgame


end

function ConnectX.Funcs.GetGame(nick)
	local pltbl = ConnectX.Players[nick]
	if pltbl then
		local sgame = ConnectX.Games[pltbl[1]]
		return sgame,pltbl[2]
	end
end

function ConnectX.Funcs.DelGame(sgame)
	local tnicks = {}
	table.foreachi(sgame.players, function(_,v)
		table.insert(tnicks,v[1])
		ConnectX.Players[v[1]] = nil
	end)
	GameServer:DelGame(sgame.hub,tnicks)
	ConnectX.Games[sgame.index] = nil
end
	
function ConnectX.Funcs.SendToPlayerNum(sgame,msg,plnum,fplnum)
	if fplnum then
		GameServer:SendToNick(sgame.hub, sgame.players[plnum][1], msg, sgame.players[fplnum][1])
	else
		GameServer:SendToNick(sgame.hub, sgame.players[plnum][1], msg)
	end
end

function ConnectX.Funcs.SendToPlayers(sgame,msg,fplnum)
	local nicks = {}
	table.foreachi(sgame.players, function(_,v)
		table.insert(nicks,v[1])
	end)
	if fplnum then
		GameServer:SendToNicks(sgame.hub,nicks,msg,sgame.players[fplnum][1])
	else
		GameServer:SendToNicks(sgame.hub,nicks,msg)
	end
end

function ConnectX.Funcs.SendBoard(sgame,toplnum)
	if toplnum then
		local font = sgame.players[toplnum][2]
		local nick = sgame.players[toplnum][1]
		local board = ConnectX.Draw[font](sgame)
		GameServer:SendToNicks(sgame.hub,{nick},board)
	else
		table.foreachi(sgame.players, function(_,v)
			local font = v[2]
			local nick = v[1]
			local board = ConnectX.Draw[font](sgame)
			GameServer:SendToNicks(sgame.hub,{nick},board)
		end)
	end
end

function ConnectX.Funcs.SwitchPlayers(sgame)
	local playernick1 = sgame.turn[1]
	table.remove(sgame.turn,1)
	table.insert(sgame.turn,playernick1)
end


function ConnectX.Funcs.CheckData(sgame,snick,arg)
	
	local inum = tonumber(arg)
	
	if (sgame.turn[1] == snick) and inum and (inum <= sgame.matrix.columns) and (inum > 0) then

		local plnum = ConnectX.Players[snick][2]
		local retinsertx,xcolumn,xline = sgame:InsertX(arg,plnum)
		
		if (retinsertx == "INSERTED") then

			sgame:SwitchPlayers()
			sgame:SendBoard()
			
			local retwon = sgame:CheckForWin(xcolumn,xline)
			if retwon then
				sgame:SendToPlayers(snick.." has won the game :)")
				return "DEL"
			end
			
			local retend = sgame:CheckForEnd()
			if retend then
				sgame:SendToPlayers("Game ended even")
				return "DEL"
			end

		else
			sgame:SendToPlayer(plnum,"FAILED: to insert in column "..inum)

		end
		return 1
	end
end

function ConnectX.Funcs.InsertX(sgame,num,plnum)

	local sfield = sgame.field

	for i = 1,sgame.matrix.lines do
		if (sfield[num..i] == 0) then
			sfield[num..i] = plnum
			sgame.icounter[1] = sgame.icounter[1] + 1
			return "INSERTED",num,i
		end
	end

	return "FAILED"
end

function ConnectX.Funcs.CheckForEnd(sgame)

	if (sgame.icounter[1] == sgame.icounter[2]) then
		return "END"
	end
end
	

function ConnectX.Funcs.CheckForWin(sgame,xcolumn,xline)

	local sfield = sgame.field
	local xconnects = sgame.matrix.connects

	local fcolumns = sgame.matrix.columns
	local flines = sgame.matrix.lines

	local xmatcher = sfield[xcolumn..xline]


	-- Check UP,DOWN

	local counter = 1

	for i = (xline+1),flines do
		if (sfield[xcolumn..i] == xmatcher) then
			counter = counter + 1
		else
			break
		end
	end

	for i = (xline-1),1,-1 do
		if (sfield[xcolumn..i] == xmatcher) then
			counter = counter + 1
		else
			break
		end
	end

	if (counter >= xconnects) then
		return "WON"
	end


	-- Check RIGHT,LEFT

	local counter = 1

	for i = (xcolumn+1),fcolumns do
		if (sfield[i..xline] == xmatcher) then
			counter = counter + 1
		else
			break
		end
	end

	for i = (xcolumn-1),1,-1 do
		if (sfield[i..xline] == xmatcher) then
			counter = counter + 1
		else
			break
		end
	end

	if (counter >= xconnects) then
		return "WON"
	end

			
	-- Check DIAGONAL: RIGHT,UP; LEFT,DOWN

	local counter = 1

	for i = 1,xconnects do
		local scol = xcolumn + i
		local sline = xline + i

		if (sfield[scol..sline] and sfield[scol..sline] == xmatcher) then
			counter = counter + 1
		else
			break
		end
	end

	for i = 1,xconnects do
		local scol = xcolumn - i
		local sline = xline - i

		if (sfield[scol..sline] and sfield[scol..sline] == xmatcher) then
			counter = counter + 1
		else
			break
		end
	end

	if (counter >= xconnects) then
		return "WON"
	end



	-- Check DIAGONAL: RIGHT,DOWN; LEFT,UP

	local counter = 1

	for i = 1,xconnects do
		local scol = xcolumn + i
		local sline = xline - i

		if (sfield[scol..sline] and sfield[scol..sline] == xmatcher) then
			counter = counter + 1
		else
			break
		end
	end

	for i = 1,xconnects do
		local scol = xcolumn - i
		local sline = xline + i

		if (sfield[scol..sline] and sfield[scol..sline] == xmatcher) then
			counter = counter + 1
		else
			break
		end
	end

	if (counter >= xconnects) then
		return "WON"
	end
end

-- Parse Data
ConnectX.Funcs.ParseData = function( hub, nick, targs, data )

	local arg1 = targs[1]
	if arg1 then
		arg1 = string.lower(arg1)
		if ConnectX.Trigs[arg1] then
			table.remove( targs, 1 )
			ConnectX.Trigs[arg1]( hub, nick, targs )
			return 1
		end
		local sgame,plnum = ConnectX.Funcs.GetGame(nick)
		if sgame then
			local ret = sgame:CheckData( nick,arg1 )
			if ret then
				if ret == "DEL" then
					sgame:DelGame()
				end
				return 1
			end
		end			
	end
	
	local sgame,plnum = ConnectX.Funcs.GetGame(nick)
	if sgame then
		sgame:SendToPlayers(data,plnum)
		return 1
	end
end

------------------------------------------
------------------------------------------
ConnectX.Trigs = {}

-- Help Trig
ConnectX.Trigs.help = function( shub, nick )
	GameServer:SendToNick( shub, nick, ConnectX.Data.Help )
end

-- Invite Trig
ConnectX.Trigs.invite = function( shub, nick, targs )
	local invited = targs[1]
	if invited and shub._users[invited] and (invited ~= nick) then

		local ret = GameServer:SetGame("ConnectX",ConnectX.Funcs.ParseData,shub,{nick,invited},nick)

		if ret then
			if not ConnectX.Funcs.GetGame(invited) then
				local sgame = ConnectX.Funcs.CreateGame( shub, {invited,nick})
				sgame:SendBoard()
				sgame:SendToPlayers("Player: "..invited.." begins")
			end
		end
	end
end

ConnectX.Trigs.inviteom = function( shub, nick, targs )

	if targs[2] then

		local invited = targs[1]
		local col,lin,conns = unpack( GameServer:Tokenize( ",", targs[2] ) )
		
		if invited and shub._users[invited] and (invited ~= nick) and col and lin and conns then

			local ret = GameServer:SetGame("ConnectX",ConnectX.Funcs.ParseData,shub,{nick,invited},nick)

			if ret then

				if not ConnectX.Funcs.GetGame(invited) then

					if (tonumber(col)<=20) and (tonumber(lin)<=20) then

						local smatrix = {}
						smatrix.columns = tonumber(col)
						smatrix.lines = tonumber(lin)
						smatrix.connects = tonumber(conns)

						local sgame = ConnectX.Funcs.CreateGame(shub,{invited,nick},smatrix)
						sgame:SendBoard()
						sgame:SendToPlayers("Player: "..invited.." begins")
					end
				end
			end
		end
	end
end

-- Quit Trig
ConnectX.Trigs.quit = function( shub,nick )
	local sgame = ConnectX.Funcs.GetGame(nick)
	if sgame then
		sgame:SendToPlayers("Player: "..nick.." quited")
		sgame:DelGame()
	end
end

-- Font Trig
ConnectX.Trigs.font = function( shub, nick, targs )
	local sgame,plnum = ConnectX.Funcs.GetGame(nick)
	if sgame then
		local sfont = targs[1]
		if sfont and ConnectX.Fonts[sfont] then
			sgame.players[plnum][2] = sfont
			sgame:SendToPlayerNum("Setted font to: "..sfont,plnum)
		end
	end
end

ConnectX.Trigs.showboard = function( shub, nick )
	local sgame,plnum = ConnectX.Funcs.GetGame(nick)
	if sgame then
		sgame:SendBoard(plnum)
	end
end

--------------------------
-- Add Game Server Trig --
--------------------------
GameServer:AddGSTrig( "cx", ConnectX.Funcs.ParseData )

-------------------------------------------------------------------------
DC():PrintDebug( "  ** Loaded ConnectX.V.001.lua **" )
-------------------------------------------------------------------------



	