-- Converted to LUA 5.0 by Chill for ClientSide (StandAlone)
-- Removed Jumble PM
-- Timed the saving of scores, to x mins, and also loading of phrases, 20 loaded at once
-- Added iGameNoReply to set if iGameNoReplyCount wished
-- Added iGameStartOnMain to set if script should start on Main()

--------
-- DC Funcs
--------

dcpp:setListener( "timer","Jumble",
	function()
		if JumbleRunFlag == 1 then
			JumbleOnTimer()
		end
	end
)

dcpp:setListener( "chat","Jumble",
	function(hub, user, data)
		local snick = user:getNick()
		JumbleDataArrival("main", hub, snick, data)
	end
)

dcpp:setListener( "pm","Jumble",
	function(hub, user, data)
		local snick = user:getNick()
		JumbleDataArrival("pm", hub, snick, data)
	end
)

-- Flag for Timer
JumbleRunFlag = 0

sAuthor = "RabidWombat";
sEmail = "cbarber@dwc.edu";

bGameRunning, bGamePaused = nil, nil;
sJumblePhrase, sActualPhrases, NoSpacePhrase = nil,nil,nil;
iLength, iBonusTime = 0, 0;
sScoreOutput, sHintOutput, sHelpOutput, sOpHelpOutput = nil, nil, nil, "";
iTimeCount, iGameNoReplyCount = 0, 0;
tScores, tScoresByName  = { n = 0 }, {};

--
tPhrases = {}
iJumbleCounter = 0
--

-- Events --

function JumbleMain()
	dofile("scripts/ChillGameServer/Jumble.Server/jumble.cfg");

	sScoreFormula = "return "..sScoreFormula;
	sBonusFormula = "return "..sBonusFormula;
	sHintFormula  = "return "..sHintFormula;

	sHelpOutput = StrReplace(tStringTable[1]);

	for cmd,tTemp in tCommands do
		if(tTemp[1] == DisplayJumbleHelp) then
			sJumbleHelp = cmd;
		end

		sCmd, sDesc = cmd, tTemp[3];

		if(tTemp[2] == 0) then
			sHelpOutput = sHelpOutput..StrReplace(tStringTable[2]);
		else
			sOpHelpOutput = sOpHelpOutput..StrReplace(tStringTable[2]);
		end
	end

	OldSendToAll = SendToAll;
	UserDisconnected = LeaveJumble;
	OpDisconnected = LeaveJumble;

	ReadScoresFromFile();
	SetScores();

	if iGameStartonMain and ( iGameStartonMain == 1 ) then
		StartJumbleGame()
	end

	GameServer:AddServer( "Jumble" )
end

function JumbleOnTimer()

	iJumbleCounter = iJumbleCounter + 1
	if (iJumbleCounter == iJumbleSaveStats) then
		WriteScoresToFile();
		iJumbleCounter = 0
	end

	if(bGamePaused) then
		iTimeCount = iTimeCount + 1;

		if(iTimeCount >= iPauseTime) then
			StartJumblePhrase();
		end
	elseif(bGameRunning) then
		iTimeCount = iTimeCount + 1;

		if(iTimeCount == iHintTime) then
			JumbleSendToPlayers(sHintOutput);
		elseif (iTimeCount == iGameEndTime - 10) then
			JumbleSendToPlayers(StrReplace(tStringTable[3]));
		elseif (iTimeCount == iGameEndTime) then
			StopJumblePhrase();
			if iGameNoReply and ( iGameNoReply == 1 ) then
				if ( iGameNoReplyCount >= 3 ) then
					StopJumbleGame();
					iGameNoReplyCount = 0
				end
			else
				iGameNoReplyCount = 0
			end
		else

		end
	else

	end
end

function JumbleSendToUser(shub, snick, data)
	DC():SendHubMessage( shub:getId(), "$To: "..snick.." From: "..shub:getOwnNick().." $<"..shub:getOwnNick().."> "..data.."|")
end

function JumbleSendToPlayers(data)
	local hubs = dcpp:getHubs()
	table.foreach(hubs, function(_,shub)
		local ret = JumbleCheckOwnNick(shub)
		if ret then
			DC():SendHubMessage( shub:getId(), "<"..shub:getOwnNick().."> "..data.."|")
		end
	end)
end

function JumbleCheckOwnNick(shub, snick)
	if GameServer and GameServer:IsHub(shub, "Jumble") then
		return 1
	end
end
	


function JumbleDataArrival(mode, shub, snick, sData)

	if JumbleCheckOwnNick(shub, snick) then
		

		local s, e, chat, cmd, args = string.find(sData, "((%S+)%s*([^%|]*))$");

		if (cmd == nil) then
			return
		end

		sUserName = snick

		cmd = string.lower(cmd);

		if(tCommands[cmd] and (tCommands[cmd][2] == 0 or shub:isOp(snick) or (snick == shub:getOwnNick()) )) then
			tCommands[cmd][1](shub, snick, args);
			return 1;
		else

			if(bGameRunning and bGamePaused == nil and string.find(string.upper(chat), sActualPhrase, 1, 1)) then

				iBonusTime = math.max(iBonusTimeLimit - iTimeCount, 0);

				iScore = assert(loadstring(StrReplace(sScoreFormula)))();
				iBonus = assert(loadstring(StrReplace(sBonusFormula)))();

				if(tScoresByName[sUserName]) then
					tScoresByName[sUserName][2] = tScoresByName[sUserName][2] + iScore + iBonus;
				else
					tScoresByName[sUserName] = {sUserName, iScore + iBonus};
					table.insert(tScores, tScoresByName[sUserName]);
				end

				iRank = SetScores(sUserName);
				iRankTotal = table.getn(tScores);
				iUserScore = tScoresByName[sUserName][2];

				StopJumblePhrase();

				if(iBonusTime ~= 0) then
					JumbleSendToPlayers(StrReplace(tStringTable[4]));
				else
					JumbleSendToPlayers(StrReplace(tStringTable[5]));
				end

				iGameNoReplyCount = 0;

				return 1;
			end
		end
	end
end

-- Command Functions --

function StartJumbleGame(shub, snick, args)

	if(bGameRunning) then return; end

	if args and (args ~= "") then
		local s, e, args = string.find(args, "([%w%s]+)$");
		args = "scripts/ChillGameServer/Jumble.Server/Jumble/"..args..".txt";
		local handle = io.open(args,"r")
		if handle then
			sJumbleWordsFile = args;
			handle:close()
		end
	end

	if snick then
		JumbleSendToPlayers(StrReplace(tStringTable[6]));
	end
	StartJumblePhrase();
	JumbleSendToPlayers(StrReplace(tStringTable[7]));

	iGameNoReplyCount = 0;
	-- Start Timer
	JumbleRunFlag = 1
end

function StopJumbleGame(shub, snick)
	if not(bGameRunning) then return; end

	if not(bGamePaused) then
		StopJumblePhrase();
	end

	if(snick) then
		JumbleSendToPlayers(StrReplace(tStringTable[8]));
	else
		JumbleSendToPlayers(StrReplace(tStringTable[21]));
		-- TODO: fix numbers
	end

	bGameRunning, bGamePaused = nil, nil;
	iBonusTime, iLength = 0, 0;
	-- instead of StopTimer()
	JumbleRunFlag = 0
end

function DisplayJumblePhrase(shub, snick)
	if(bGameRunning and not bGamePaused) then
		if(snick == nil) then
			JumbleSendToPlayers(StrReplace(tStringTable[9]));
		else
			JumbleSendToUser(shub, snick, StrReplace(tStringTable[9]));
		end
	end
end

function DisplayJumbleHelp(shub, snick)
	if(shub:isOp(snick)) then
		JumbleSendToUser(shub, snick, sHelpOutput..sOpHelpOutput);
	else
		JumbleSendToUser(shub, snick, sHelpOutput);
	end
end

function DisplayJumbleScores(shub, snick)
	JumbleSendToUser(shub, snick, sScoresOutput);
end

function DisplayMyJumbleScore(shub, snick)

	if(tScoresByName[snick]) then

		iRank = tScoresByName[snick][3];
		iRankTotal = table.getn(tScores);
		iUserScore = tScoresByName[snick][2];
		JumbleSendToUser(shub, snick, StrReplace(tStringTable[10]));

	else
		JumbleSendToUser(shub, snick, StrReplace(tStringTable[11]));
	end
end

function DisplayJumbleHint(shub, snick)
	if(iTimeCount >= iHintTime) then
		JumbleSendToUser(shub, snick, sHintOutput);
	end
end

-- Jumble Phrase Functions --

function JumbleString(str)
	local tStr = { n = 0; };
	local newString = "";

	string.gsub(str, "(.)", function(c) table.insert(tStr, c); end);

	math.randomseed(os.clock());

	-- Fisher-Yates shuffle
	for n = table.getn(tStr), 1, -1 do
		local pos = math.random(n);
		newString = tStr[pos].." "..newString;
		tStr[pos] = tStr[n];
	end

	return newString;
end

function JumblePhrase(phr)
	return string.sub(string.gsub(phr, "(%S+)", function (w) return JumbleString(w).."  "; end), 1, -2);
end

-------------------------------
function JumbleGetNewPhrases()

	local nget = 20

	local hFile = io.open(sJumbleWordsFile, "r");

	if(hFile == nil) then
		JumbleSendToPlayers("Error opening "..sJumbleWordsFile);
		return;
	end

	local _, phr = nil, nil;
	local iFileSize = hFile:seek("end")

	math.randomseed(os.clock());

	for i = 1,nget do
		while(phr == nil) do
			hFile:seek("set", math.random(iFileSize)-1);
 			_, phr = hFile:read("*l", "*l");
		end
		table.insert(tPhrases,phr)
		phr = nil
	end
	hFile:close();
end

function JumbleGetPhrase()
	if (table.getn(tPhrases) == 0) then
		JumbleGetNewPhrases()
	end
	local phrase = tPhrases[table.getn(tPhrases)]
	table.remove(tPhrases)
	return phrase
end
-----------------------------

function StartJumblePhrase()

	local phr = JumbleGetPhrase()

	sActualPhrase = string.upper(phr);
	sNoSpacePhrase = string.gsub(sActualPhrase, "%s", "");
	sJumblePhrase = JumblePhrase(sActualPhrase);
	iLength = string.len(sNoSpacePhrase);

	SetJumbleHint();

	JumbleSendToPlayers(StrReplace(tStringTable[9]));

	iTimeCount = 0;
	bGameRunning = 1;
	bGamePaused = nil;
end

function StopJumblePhrase()
	JumbleSendToPlayers(StrReplace(tStringTable[15]));
	sActualPhrase, sNoSpacePhrase, sJumblePhrase = nil, nil, nil;

	iTimeCount = 0;
	bGamePaused = 1;
	iGameNoReplyCount = iGameNoReplyCount + 1;
end

-- String Functions --

function StrReplace(sString)
	sString = string.gsub(sString, "%$(%w+)", function (w)
		if(string.sub(w,1,1) == "$") then
			return string.sub(w,2,-1);
		else
			return _G[w] or "nil";
		end
	end);

	return sString;
end

-- Score Functions --

function SetScores(sName)
	local iCount = table.getn(tScores);
	iDisplayCount = iDisplayScores or iCount

	if(iDisplayScores) then
		sScoresOutput = StrReplace(tStringTable[16]);
	else
		sScoresOutput = StrReplace(tStringTable[17]);
	end

	if(iCount == 0) then
		sScoresOutput = StrReplace(tStringTable[18]);
	else
		table.sort(tScores, function(a, b) return a[2] > b[2]; end);

		for i = 1, iCount, 1 do
			tScores[i][3] = i;	-- set ranks for all users
		end

		for i = 1, math.min(iDisplayCount, iCount), 1 do
			iPos = i;
			sUserName = tScores[iPos][1];
			iUserScore = tScores[iPos][2];
			sScoresOutput = sScoresOutput..StrReplace(tStringTable[19]);
		end
	end

	sUserName = sName;

	if(sName) then
		return tScoresByName[sName][3];
	end
end

function ReadScoresFromFile()
	local f = loadfile(sJumbleScoresFile);
	if f then
		f()
	end

	if (table.getn(tScores) ~= 0) then
		WriteScoresToFile()
	end

	for i = 1, table.getn(tScores), 1 do
		tScoresByName[tScores[i][1]] = tScores[i];
	end
end

function WriteScoresToFile()
	local hFile = io.open(sJumbleScoresFile, "w");

	hFile:write("tScores = {\n");

	for i = 1, table.getn(tScores), 1 do
		hFile:write("["..i.."] = {"..string.format("%q", tScores[i][1])..","..tScores[i][2].."},\n");
	end

	hFile:write("n="..table.getn(tScores).."\n");

	hFile:write("};");

	hFile:close()
end

-- Hint Functions --

function SetJumbleHint()
	local tRevealArray = { };

	local iReveal = assert(loadstring(StrReplace(sHintFormula)))();

	local iPos = nil;

	while(iReveal > 0) do
		repeat iPos = math.random(iLength); until tRevealArray[iPos] == nil

		tRevealArray[iPos] = 1;
		iReveal = iReveal - 1;
	end

	tRevealArray.iPos = 1;

	sHint = string.gsub(sActualPhrase, "(%S)", function (c) 
		if (c == nil) then return ""; end

		local out, tTemp = nil, tRevealArray;

		if(tTemp[tTemp.iPos]) then
			out = c;
		else
			out = sHintChar;
		end

		tTemp.iPos = tTemp.iPos + 1;
		return out.." ";
	end);

	sHint = string.sub(sHint, 1, -2);

	sHintOutput = StrReplace(tStringTable[20]);
end

-- Execute
JumbleMain()

----------------------------
----------------------------
DC():PrintDebug( "  ** Loaded Jumble.lua by RabidWombat **" )