
-- Checks if Figure is allowed to move between Startpiont and Endpoint
-- awaits arguement curgame,from1,from2,to1,to2  curgame = currentgame, from1, from2, to1, to2 = from Line, from Chink, to Line, to Chink
-- returns status,errl,errc
-- status can be "MOVE" or "FAILED"
-- When "FAILED", errl and errc are errorline and errorchink if present

-------------------------------------
--		MOVES
-------------------------------------
RasChess._Moves = {}
------------------
------------------
RasChess._Moves.King = function(curgame,from1,from2,to1,to2)

	--Move : Left -> Right : Right -> Left
	if (from1 == to1) and (((from2-to2) == 1) or ((to2-from2) == 1)) then
		return("MOVE")

	--Move : Up -> Down : Down -> Up
	elseif (from2 == to2) and (((to1-from1) == 1) or ((from1-to1) == 1)) then
		return("MOVE")

	--Move : 1 Right,Left : 1 Down,Up
	elseif (((to2-from2) == 1) or ((from2-to2) == 1)) and (((to1-from1) == 1) or ((from1-to1) == 1)) then
		return("MOVE")
	end

	return("FAILED")
end
------------------
------------------
RasChess._Moves.Queen = function(curgame,from1,from2,to1,to2)

	--Move : Left -> Right
	if (from1 == to1) and (from2 < to2) then
		for i = (from2+1),(to2-1),1 do
			if (curgame[from1..i].posession ~= "") then
				return "FAILED",from1,i
			end
		end
		return("MOVE")

	--Move : Right -> Left
	elseif (from1 == to1) and (from2 > to2) then
		for i = (from2-1),(to2+1),-1 do
			if (curgame[from1..i].posession ~= "") then
				return "FAILED",from1,i
			end
		end
		return("MOVE")

	--Move : Up -> Down
	elseif (from2 == to2) and (from1 < to1) then	
		for i = (from1+1),(to1-1),1 do
			if (curgame[i..from2].posession ~= "") then
				return "FAILED",i,from2
			end
		end
		return("MOVE")

	--Move : Down -> Up
	elseif (from2 == to2) and (from1 > to1) then	
		for i = (from1-1),(to1+1),-1 do
			if (curgame[i..from2].posession ~= "") then
				return "FAILED",i,from2
			end
		end
		return("MOVE")

	--Move : Left -> Right, Up -> Down
	elseif (from1 < to1) and (from2 < to2) and ((to1-from1) == (to2-from2)) then	
		for i = 1,(to1-from1-1),1 do
			if (curgame[(from1+i)..(from2+i)].posession ~= "") then
				return "FAILED",(from1+i),(from2+i)
			end
		end
		return("MOVE")

	--Move : Left -> Right, Down -> Up
	elseif (from1 < to1) and (from2 > to2) and ((to1-from1) == (from2-to2)) then	
		for i = 1,(to1-from1-1),1 do
			if (curgame[(from1+i)..(from2-i)].posession ~= "") then
				return "FAILED",(from1+i),(from2-i)
			end
		end
		return("MOVE")

	--Move : Right -> Left, Down -> Up
	elseif (from1 > to1) and (from2 > to2) and ((from1-to1) == (from2-to2)) then	
		for i = 1,(from1-to1-1),1 do
			if (curgame[(from1-i)..(from2-i)].posession ~= "") then
				return "FAILED",(from1-i),(from2-i)
			end
		end
		return("MOVE")

	--Move : Right -> Left, Up -> Down
	elseif (from1 > to1) and (from2 < to2) and ((from1-to1) == (to2-from2)) then	
		for i = 1,(from1-to1-1),1 do
			if (curgame[(from1-i)..(from2+i)].posession ~= "") then
				return "FAILED",(from1-i),(from2+i)
			end
		end
		return("MOVE")
	end

	return "FAILED"
end
------------------
------------------
RasChess._Moves.Bishop = function(curgame,from1,from2,to1,to2)

	--Move : Left -> Right, Up -> Down
	if (from1 < to1) and (from2 < to2) and ((to1-from1) == (to2-from2)) then	
		for i = 1,(to1-from1-1),1 do
			if (curgame[(from1+i)..(from2+i)].posession ~= "") then
				return "FAILED",(from1+i),(from2+i)
			end
		end
		return("MOVE")

	--Move : Left -> Right, Down -> Up
	elseif (from1 < to1) and (from2 > to2) and ((to1-from1) == (from2-to2)) then	
		for i = 1,(to1-from1-1),1 do
			if (curgame[(from1+i)..(from2-i)].posession ~= "") then
				return "FAILED",(from1+i),(from2-i)
			end
		end
		return("MOVE")

	--Move : Right -> Left, Down -> Up
	elseif (from1 > to1) and (from2 > to2) and ((from1-to1) == (from2-to2)) then	
		for i = 1,(from1-to1-1),1 do
			if (curgame[(from1-i)..(from2-i)].posession ~= "") then
				return "FAILED",(from1-i),(from2-i)
			end
		end
		return("MOVE")

	--Move : Right -> Left, Up -> Down
	elseif (from1 > to1) and (from2 < to2) and ((from1-to1) == (to2-from2)) then	
		for i = 1,(from1-to1-1),1 do
			if (curgame[(from1-i)..(from2+i)].posession ~= "") then
				return "FAILED",(from1-i),(from2+i)
			end
		end
		return("MOVE")
	end

	return "FAILED"
end
------------------
------------------
RasChess._Moves.Horse = function(curgame,from1,from2,to1,to2)

	--Move : 2 Down, 2 Up, 1 Left, 1 Right
	if ((to1-from1 == 2) or (from1-to1 == 2)) and ((to2-from2 == 1) or (from2-to2 == 1)) then
		return("MOVE")

	--Move : 1 Down, 1 Up, 2 Left, 2 Right
	elseif ((to1-from1 == 1) or (from1-to1 == 1)) and ((to2-from2 == 2) or (from2-to2 == 2)) then
		return("MOVE")
	end

	return("FAILED")
end
------------------
------------------
RasChess._Moves.Castle = function(curgame,from1,from2,to1,to2)
	--Move : Left -> Right
	if (from1 == to1) and (from2 < to2) then
		for i = (from2+1),(to2-1),1 do
			if (curgame[from1..i].posession ~= "") then
				return "FAILED",from1,i
			end
		end
		return("MOVE")

	--Move : Right -> Left
	elseif (from1 == to1) and (from2 > to2) then
		for i = (from2-1),(to2+1),-1 do
			if (curgame[from1..i].posession ~= "") then
				return "FAILED",from1,i
			end
		end
		return("MOVE")

	--Move : Up -> Down
	elseif (from2 == to2) and (from1 < to1) then	
		for i = (from1+1),(to1-1),1 do
			if (curgame[i..from2].posession ~= "") then
				return "FAILED",i,from2
			end
		end
		return("MOVE")

	--Move : Down -> Up
	elseif (from2 == to2) and (from1 > to1) then	
		for i = (from1-1),(to1+1),-1 do
			if (curgame[i..from2].posession ~= "") then
				return "FAILED",i,from2
			end
		end
		return("MOVE")
	end

	return("FAILED")
end
------------------
------------------
RasChess._Moves.Pawn = function(curgame,from1,from2,to1,to2)

	if curgame.sides.Top == curgame.players[1] then
		if (from2 == to2) and (curgame[to1..to2].posession == "") then
			if (from1 == 2) and (to1 == 4) and (curgame[(to1-1)..to2].posession == "") then
				return("MOVE")
			elseif ((to1-from1) == 1) then
				return("MOVE")
			end
		elseif ((to1-from1) == 1) and (((from2-to2) == 1) or ((to2-from2) == 1)) and (curgame[to1..to2].posession == curgame.players[2]) then
			return("MOVE")
		end

	elseif curgame.sides.Bottom == curgame.players[1] then
		if (from2 == to2) and (curgame[to1..to2].posession == "") then
			if (from1 == 7) and (to1 == 5) and (curgame[(to1+1)..to2].posession == "") then
				return("MOVE")
			elseif ((to1-from1) == -1) then
				return("MOVE")
			end
		elseif ((to1-from1) == -1) and (((from2-to2) == 1) or ((to2-from2) == 1)) and (curgame[to1..to2].posession == curgame.players[2]) then
			return("MOVE")
		end
	end

	return("FAILED")
end