-- Tic Tac Toe V.001 by chill LUA 5.0
-- board by UwV 10/04
-- Now this version is Best viewed with Microsoft Sans Serif, Size _8_
-- N.B. there is some difference between MS sans and Micro.. sans


-----------------------------------------------------------------------
-----------------------------------------------------------------------
-- 		************* MAIN SCRIPT *************              --
-----------------------------------------------------------------------
-----------------------------------------------------------------------

-- Main Table

TTTServ = {}

-- Table for Games
TTTServ.Games = {}

-- Tables for Players
TTTServ.Players = {}

------------------------------------------
------------------------------------------
-- Table For Data
TTTServ.Data = {}

-- TTT Help
TTTServ.Data.Help = "--- Tic Tac Toe Help ( by chill ) ---\r\n\r\n"..
	"\t-----------------------------------\r\n"..
	"\tttt invite <nick>    - Invite a user\r\n"..
	"\tquit    - Quit the current game\r\n"..
	"\thelp    - Shows you TicTacToe help\r\n"..
	"\t-----------------------------------\r\n"


TTTServ.Data.Color1 = "}<}}'>"	-- invitor  
TTTServ.Data.Color2 = ";{~'~};"	-- invited

TTTServ.Data.Arrow = "-->"

------------------------------------------
------------------------------------------
-- Table for Functions
TTTServ.Func = {}

-- Parse Data
TTTServ.Func.ParseData = function(shub,snick, targs, data)
	local arg1 = targs[1]
	if arg1 then
		arg1 = string.lower(arg1)
		if TTTServ.Trig[arg1] then
			table.remove( targs, 1 )
			TTTServ.Trig[arg1]( shub, snick, targs)
			return 1
		end
		local sgame = TTTServ.Func.GetGame(snick)
		if sgame then
			local ret = sgame:CheckData(snick,arg1)
			if ret then
				if ret == "DEL" then
					sgame:DelGame()
				end
				return 1
			end
		end			
	end
	
	local sgame = TTTServ.Func.GetGame(snick)
	if sgame then
		sgame:SendToOtherPlayer(data,snick)
		return 1
	end
end

-- Create Game
function TTTServ.Func.CreateGame(shub,nick1,nick2)

	-- Get a New Game Index
	local sindex = ""
	local found = 1
	while found do
		sindex = sindex..string.char(math.random(48,122))
		if not TTTServ.Games[sindex] then
			found = nil
		end
	end

	TTTServ.Players[nick1] = sindex
	TTTServ.Players[nick2] = sindex

	-- TTT Game
	TTTServ.Games[sindex] = {}

	local sgame = TTTServ.Games[sindex]

	sgame.index = sindex

	sgame.hub = shub
	sgame.board = {
		A1 = "          ",
		A2 = "          ",
		A3 = "          ",
		B1 = "          ",
		B2 = "          ",
		B3 = "          ",
		C1 = "          ",
		C2 = "          ",
		C3 = "          ",
	}

	sgame.tplayer = { nick1,TTTServ.Data.Color1 }
	sgame.bplayer = { nick2,TTTServ.Data.Color2 }

	sgame.turn = sgame.bplayer

	-- Assign Functions

	sgame.SendPlayerTop = TTTServ.Func.SendPlayerTop
	sgame.SendPlayerBot = TTTServ.Func.SendPlayerBot
	sgame.SendToOtherPlayer = TTTServ.Func.SendToOtherPlayer
	sgame.SendToPlayers = TTTServ.Func.SendToPlayers
	sgame.SendBoard = TTTServ.Func.SendBoard

	sgame.CheckData = TTTServ.Func.CheckData

	sgame.CheckForWin = TTTServ.Func.CheckForWin
	sgame.CheckForEnd = TTTServ.Func.CheckForEnd


	sgame.SwitchPlayers = TTTServ.Func.SwitchPlayers

	sgame.DelGame = TTTServ.Func.DelGame

	return sgame
end

function TTTServ.Func.SendPlayerTop(sgame,msg,fnick)
	GameServer:SendToNicks(sgame.hub,{sgame.tplayer[1]},msg,fnick)
end

function TTTServ.Func.SendPlayerBot(sgame,msg,fnick)
	GameServer:SendToNicks(sgame.hub,{sgame.tplayer[1]},msg,fnick)
end

function TTTServ.Func.SendToPlayers(sgame,msg)
	GameServer:SendToNicks(sgame.hub,{sgame.tplayer[1],sgame.bplayer[1]},msg)
end

function TTTServ.Func.SendToOtherPlayer(sgame,msg,fnick)
	if (sgame.tplayer[1] == fnick) then
		GameServer:SendToNicks(sgame.hub,{sgame.bplayer[1]},msg,fnick)
	else
		GameServer:SendToNicks(sgame.hub,{sgame.tplayer[1]},msg,fnick)
	end
end	

function TTTServ.Func.SendBoard(sgame)
	local sboard = TTTServ.Func.SendBoard(sgame)
	GameServer:SendToNicks(sgame.hub,{sgame.tplayer[1],sgame.bplayer[1]},sboard)
end

function TTTServ.Func.SendBoard(sgame)

	local tplayer,bplayer = sgame.tplayer[1],sgame.bplayer[1]

	if (sgame.turn[1] == sgame.tplayer[1]) then
		tplayer = TTTServ.Data.Arrow.." "..sgame.tplayer[1]
	else
		bplayer = TTTServ.Data.Arrow.." "..sgame.bplayer[1]
	end

	local A1,A2,A3 = sgame.board.A1,sgame.board.A2,sgame.board.A3
	local B1,B2,B3 = sgame.board.B1,sgame.board.B2,sgame.board.B3
	local C1,C2,C3 = sgame.board.C1,sgame.board.C2,sgame.board.C3

	local TicTacToeGame = "\r\n\r\n"..
	"\t\t"..tplayer.." : "..sgame.tplayer[2].."\r\n"..
	"\t ___________________________\r\n"..
	"\tl           1             2             3           l\r\n"..
	"\tl    l  "..string.char(166)..""..string.char(166).."  "..string.char(166)..""..string.char(166).."  l    l\r\n"..
	"\tl'A l  "..A1.."  "..string.char(166)..""..string.char(166).."  "..A2.."  "..string.char(166)..""..string.char(166).."  "..A3.."  l    l\r\n"..
	"\tl    l_ _ _ _ _"..string.char(166)..""..string.char(166).."_ _ _ _ _"..string.char(166)..""..string.char(166).."_ _ _ _ _l    l\r\n"..
	"\tl    l    "..string.char(166)..""..string.char(166).."    "..string.char(166)..""..string.char(166).."    l    l\r\n"..
	"\tl'B l  "..B1.."  "..string.char(166)..""..string.char(166).."  "..B2.."  "..string.char(166)..""..string.char(166).."  "..B3.."  l    l\r\n"..
	"\tl    l_ _ _ _ _"..string.char(166)..""..string.char(166).."_ _ _ _ _"..string.char(166)..""..string.char(166).."_ _ _ _ _l    l\r\n"..
	"\tl    l    "..string.char(166)..""..string.char(166).."    "..string.char(166)..""..string.char(166).."    l    l\r\n"..
	"\tl'C l  "..C1.."  "..string.char(166)..""..string.char(166).."  "..C2.."  "..string.char(166)..""..string.char(166).."  "..C3.."  l    l\r\n"..
	"\tl    l__ __ __"..string.char(166)..""..string.char(166).."__ __ __"..string.char(166)..""..string.char(166).."__ __ __l    l\r\n"..
	"\tl___________________________l\r\n\r\n"..
	"\t\t"..bplayer.." : "..sgame.bplayer[2].."\r\n"

	sgame:SendToPlayers(TicTacToeGame)
end

-- Check the Data
function TTTServ.Func.CheckData(sgame,nick,arg)
	if (sgame.turn[1] == nick) then
		arg = string.upper(arg)
		if sgame.board[arg] and (sgame.board[arg] == "          ") then
	
			sgame.board[arg] = sgame.turn[2]

			sgame:SwitchPlayers()
			sgame:SendBoard()
			
			local retwon = sgame:CheckForWin()
			if retwon then
				sgame:SendToPlayers(nick.." has won the game :)")
				return "DEL"
			end
			
			local retend = sgame:CheckForEnd()
			if retend then
				sgame:SendToPlayers("Game ended even")
				return "DEL"
			end

			return 1
		end
	end
end

-- Check For Win
function TTTServ.Func.CheckForWin(sgame)
	
	local curGame = sgame.board
	
	if curGame.A1 ~= "          " and curGame.A1 == curGame.A2 and curGame.A1 == curGame.A3 then
		return("WON")
	elseif curGame.B1 ~= "          " and curGame.B1 == curGame.B2 and curGame.B1 == curGame.B3 then
		return("WON")
	elseif curGame.C1 ~= "          " and curGame.C1 == curGame.C2 and curGame.C1 == curGame.C3 then
		return("WON")
	elseif curGame.A1 ~= "          " and curGame.A1 == curGame.B1 and curGame.A1 == curGame.C1 then
		return("WON")
	elseif curGame.A2 ~= "          " and curGame.A2 == curGame.B2 and curGame.A2 == curGame.C2 then
		return("WON")
	elseif curGame.A3 ~= "          " and curGame.A3 == curGame.B3 and curGame.A3  == curGame.C3 then
		return("WON")
	elseif curGame.A1 ~= "          " and curGame.A1 == curGame.B2 and curGame.A1 == curGame.C3 then
		return("WON")
	elseif curGame.A3 ~= "          " and curGame.A3 == curGame.B2 and curGame.A3 == curGame.C1 then
		return("WON")
	end
end

-- Check for End
function TTTServ.Func.CheckForEnd(sgame)

	local curGame = sgame.board
	count = 0
	
	table.foreach(curGame, function(_,v)
		if (v ~= "          ") then
			count = count + 1
		end
	end)
	
	if count == 9 then
		return("END")
	end
	count = nil
end

-- Switch Players
function TTTServ.Func.SwitchPlayers(sgame)
	if (sgame.tplayer[1] == sgame.turn[1]) then
		sgame.turn = sgame.bplayer
	else
		sgame.turn = sgame.tplayer
	end
end

-- Get Game
TTTServ.Func.GetGame = function(nick)
	local index = TTTServ.Players[nick]
	if index then
		local sgame = TTTServ.Games[index]
		return sgame
	end
end

-- Delete Game
TTTServ.Func.DelGame = function(sgame)

	GameServer:DelGame(sgame.hub,{sgame.tplayer[1],sgame.bplayer[1]})

	TTTServ.Players[sgame.tplayer[1]] = nil
	TTTServ.Players[sgame.bplayer[1]] = nil
	TTTServ.Games[sgame.index] = nil
end

------------------------------------------
------------------------------------------
TTTServ.Trig = {}

-- Help Trig
TTTServ.Trig.help = function( shub, nick )
	GameServer:SendToNicks(shub,{nick},TTTServ.Data.Help)
end

-- Invite Trig
TTTServ.Trig.invite = function( shub, nick, targs )
	local invited = targs[1]
	if invited and shub._users[invited] and (invited ~= nick) then

		local ret = GameServer:SetGame("TicTacToe",TTTServ.Func.ParseData,shub,{nick,invited},nick)

		if ret then
			if not TTTServ.Func.GetGame(invited) then
				local sgame = TTTServ.Func.CreateGame(shub,nick,invited)
				sgame:SendBoard()
				sgame:SendToPlayers("Player: "..invited.." begins")
			end
		end
	end
end

-- Invite Trig
TTTServ.Trig.quit = function( shub, nick )
	local sgame = TTTServ.Func.GetGame(nick)
	if sgame then
		sgame:SendToPlayers("Player: "..nick.." quited")
		sgame:DelGame()
	end
end


-- Game Server
GameServer._GSTrigs.ttt = TTTServ.Func.ParseData

-------------------------------------------------------------------------
DC():PrintDebug( "  ** Loaded TTT.V.001.lua **" )
-------------------------------------------------------------------------